#ifndef  _TIM_C_H_
#define _TIM_C_H_

#include "tim_comm_c.h"
#include "tim_conv_c.h"
#include "tim_msg_c.h"
#include "tim_status_c.h"


extern "C" 
{
	TIM_DECL int	TIMSwitchEnv(int env);
	TIM_DECL void	TIMSetEnv(int env);
	TIM_DECL int	TIMEnv();
	TIM_DECL void	TIMSetMode(int mode);
	TIM_DECL int	TIMMode();
	TIM_DECL void	TIMSetPath(const char* path);
	TIM_DECL int	TIMGetPath(char* path, uint32_t* len);
	TIM_DECL void	TIMSetLogLevel(TIMLogLevel level);
	TIM_DECL void	TIMSetLogPrint(bool flag);
	TIM_DECL bool	TIMGetLogPrint();
	TIM_DECL TIMLogLevel TIMGetLogLevel();
	
	TIM_DECL int	TIMReady();

	TIM_DECL int	TIMInit();
	TIM_DECL int	TIMUninit();

	TIM_DECL int	TIMLogin(int sdk_app_id, const TIMUserInfo *tim_user, const char* user_sig, TIMCommCB *callback);
	TIM_DECL void	TIMLogout(TIMCommCB *callback);


	TIM_DECL uint64_t	TIMGetConversationCount();
	TIM_DECL int		TIMGetConversation(TIMConversationHandle handle, TIMConversationType type, const char* peer);
	TIM_DECL bool		TIMDeleteConversation(TIMConversationType type, const char* peer);
	TIM_DECL int		TIMGetConversationByIndex(TIMConversationHandle handle, uint64_t index);
	TIM_DECL void		TIMUploadLogFile(const char* filename, const char* tag);
	TIM_DECL void		TIMDisableStorage();

	TIM_DECL void			TIMSetMessageCallBack(TIMMessageCB *callback);
	TIM_DECL TIMMessageCB *	TIMGetMessageCallBack();

	TIM_DECL void		TIMSetConnCallBack(TIMConnCB *callback);
	TIM_DECL TIMConnCB*	TIMGetConnCallBack();

	TIM_DECL void		TIMSetKickOfflineCallBack(TIMForceOfflineCB* callback);
	TIM_DECL TIMForceOfflineCB* TIMGetKickOfflineCallBack();

	TIM_DECL void		TIMSetStatusChangeCallBack(TIMStatusChangeCB *callback);
	TIM_DECL TIMStatusChangeCB* TIMGetStatusChangeCallBack();

	TIM_DECL TIMNetworkStatus TIMGetNetWorkStatus();
	TIM_DECL int64_t TIMGetServerTimeDiff();

	// return ½ûidentifierδ¼ط
	TIM_DECL int TIMGetLoginUser(char* id, uint32_t* len);

	TIM_DECL const char*TIMGetSDKVersion();

};


#endif