#ifndef _TIM_GROUP_C_H_
#define _TIM_GROUP_C_H_

#include "tim_comm_c.h"
#include "tim_msg_c.h"

#define TIM_PRIVATE_GROUP "Private"
#define TIM_PUBLIC_GROUP  "Public"
#define TIM_CHATROOM_GROUP "ChatRoom"

//ʧ
#define TIM_GROUP_MEMBER_STATUS_FAIL 0
//ɹ
#define TIM_GROUP_MEMBER_STATUS_SUCC 1

extern "C"
{
//handle
	//չֶ handle
	typedef void* TIMGroupCustomInfoHandle;

	//ȺϢ handle
	typedef void* TIMNewGroupMemberInfoHandle;
	typedef void* TIMNewGroupInfoHandle;
	
	//ȡȺϢѡ
	typedef void* TIMGetGroupDetailInfoOptionHandle;
	typedef void* TIMGetGroupMemberInfoOptionHandle;

	//޸ȺϢѡ
	typedef void* TIMModifyGroupMemberInfoOptionHandle;
	typedef void* TIMModifyGroupBaseInfoOptionHandle;

	//ӿڻصϢ
	typedef void* TIMGroupBaseInfoHandle;
	typedef void* TIMGroupDetailInfoHandle;
	typedef void* TIMGroupMemberInfoHandle;
	typedef void* TIMGroupMemberResultHandle;

//struct and const num

	typedef enum _E_TIMGetGroupBaseInfoFlag
	{
		kGetNone =			0x00,
		kGetGroupName =		0x01,
		kGetCreateTime =	0x01 << 1,
		kGetOwnerUin =		0x01 << 2,
		kGetInfoSeq =		0x01 << 3,
		kGetLastInfoTime =	0x01 << 4,
		kGetNextMsgSeq =	0x01 << 5,
		kGetLastMsgTime =	0X01 << 6,
		kGetAppId =			0x01 << 7,
		kGetMemberNum =		0x01 << 8,
		kGetMaxMemberNum =	0x01 << 9,
		kGetNotification =	0x01 << 10,
		kGetIntroDuction =	0x01 << 11,
		kGetFaceUrl =		0x01 << 12,
		kGetAddOpton =		0x01 << 13,
		kGetGroupType =		0x01 << 14,
		kGetGroupLastMsg =  0x01 << 15,
	}TIMGetGroupBaseInfoFlag;

	typedef enum _E_TIMGetGroupMemInfoFlag
	{
		kJionTime	= 0x01,
		kMsgFlag	= 0x01 << 1,
		kRole		= 0x01 << 3,
		kShutupUntill= 0x01 << 4,
	}TIMGetGroupMemInfoFlag;

	typedef enum _E_TIMModifyGroupMemberFlag
	{
		kModifyMsgFlag = 0x01,		// Ϣѡ0գ1ܾ. СȨ: ROOT    Լ޸
		kModifyRole = 0x01 << 1,	// Ⱥݣ300ʾΪԱ.  СȨ: ROOT    Լ޸
		kModifyShutupTime = 0x01 << 2,  // ʱ,λ:.           СȨ: Ա  Լ޸
	}TIMModifyGroupMemberFlag;

	typedef enum _T_TIMModifyGroupFlag
	{
		kModifyNone	=			0x00,
		kModifyGroupName =		0x01,
		kModifyNotification =	0x01 << 1,
		kModifyIntroduction =	0x01 << 2,
		kModifyFaceUrl =		0x01 << 3,
		kModifyAddOption =		0x01 << 4,  // Ⱥѡ0ֹ룻1Ҫ2룻
		kModifyMaxMmeberNum =	0x01 << 5,  // ȺԱROOTԲ
	}TIMModifyGroupFlag;

	//Ⱥѡ
	typedef enum _E_TIMGroupAddOpt
	{
		TIM_GROUP_ADD_FORBID    = 0, //ֹȺ
		TIM_GROUP_ADD_AUTH		= 1, //ҪԱ
		TIM_GROUP_ADD_ANY       = 2, // κ˿Լ
	}TIMGroupAddOpt;

// handle operation
	TIM_DECL TIMGroupCustomInfoHandle CreateGroupCustomInfoHandle();
	TIM_DECL void DestroyGroupCustomInfoHandle(TIMGroupCustomInfoHandle handle);
	TIM_DECL TIMGroupCustomInfoHandle CloneGroupCustomInfoHandle(TIMGroupCustomInfoHandle handle);
	//value 512ֽ
	TIM_DECL bool AddGroupCustomInfo(TIMGroupCustomInfoHandle handle, const char* key, const uint32_t key_len, const char* value, const uint32_t value_len);
	TIM_DECL uint32_t GetGroupCustomInfoNum(TIMGroupCustomInfoHandle handle);
	TIM_DECL int GetGroupCustomInfo(TIMGroupCustomInfoHandle handle, char* key, uint32_t key_len, char* value, uint32_t* value_len);
	TIM_DECL int GetGroupCustomInfoByIndex(TIMGroupCustomInfoHandle handle, int index, char* key, uint32_t* key_len, char* value, uint32_t* value_len);
	

	TIM_DECL TIMNewGroupMemberInfoHandle CreateNewGroupMemberInfoHandle();
	TIM_DECL void DestroyNewGroupMemberInfoHandle(TIMNewGroupMemberInfoHandle handle);
	TIM_DECL void SetNewGroupMemberInfoIdentifier(TIMNewGroupMemberInfoHandle handle, const char* identifier);
	TIM_DECL void SetNewGroupMemberInfoMemberRole(TIMNewGroupMemberInfoHandle handle, int member_role);
	TIM_DECL void SetNewGroupMemberInfoCustomInfo(TIMNewGroupMemberInfoHandle handle, TIMGroupCustomInfoHandle custom_info);

	TIM_DECL TIMNewGroupInfoHandle CreateNewGroupInfoHandle();
	TIM_DECL void DestroyNewGroupInfoHandle(TIMNewGroupInfoHandle handle);
	TIM_DECL void SetNewGroupInfoGroupType(TIMNewGroupInfoHandle handle, const char* group_type);
	TIM_DECL void SetNewGroupInfoGroupName(TIMNewGroupInfoHandle handle, const char* group_name, const uint32_t name_len);
	TIM_DECL void SetNewGroupInfoGroupMembers(TIMNewGroupInfoHandle handle, TIMNewGroupMemberInfoHandle* members, const uint32_t num);
	TIM_DECL void SetNewGroupInfoGroupNotification(TIMNewGroupInfoHandle handle, const char* notification, const uint32_t nofi_len);
	TIM_DECL void SetNewGroupInfoGroupIntroduction(TIMNewGroupInfoHandle handle, const char* introduction, const uint32_t intro_len);
	TIM_DECL void SetNewGroupInfoFaceUrl(TIMNewGroupInfoHandle handle, const char* face_url, const uint32_t face_url_len);
	TIM_DECL void SetNewGroupInfoAddOption(TIMNewGroupInfoHandle handle, const TIMGroupAddOpt opt);
	TIM_DECL void SetNewGroupInfoMaxMemberNum(TIMNewGroupInfoHandle handle, const uint32_t max_member_num);
	TIM_DECL void SetNewGroupInfoGroupCustomInfo(TIMNewGroupInfoHandle handle, TIMGroupCustomInfoHandle custom_info_handle);

	TIM_DECL TIMGetGroupDetailInfoOptionHandle CreateGetGroupDetailInfoOptionHandle();
	TIM_DECL void DestoryGetGroupDetailInfoOptionHandle(TIMGetGroupDetailInfoOptionHandle handle);
	TIM_DECL int SetFlag4GetGroupDetailInfoOptionHandle(TIMGetGroupDetailInfoOptionHandle handle, TIMGetGroupBaseInfoFlag flag);
	TIM_DECL int SetCustomInfo4GetGroupDetailnfoOptionHandle(TIMGetGroupDetailInfoOptionHandle handle, TIMGroupCustomInfoHandle custom_info_handle);
	TIM_DECL int SetGroups4GetGroupDetailInfoOptionHandle(TIMGetGroupDetailInfoOptionHandle handle, char** group_id, uint32_t group_num);

	TIM_DECL TIMGetGroupMemberInfoOptionHandle CreateGetGroupMemberInfoOptionHandle();
	TIM_DECL void DestroyGetGroupMemberInfoOptionHandle(TIMGetGroupMemberInfoOptionHandle handle);
	TIM_DECL int SetGroupMember4GetGroupMemberInfoOptionHandle(TIMGetGroupMemberInfoOptionHandle handle, char** members_id, uint32_t member_num);
	TIM_DECL int SetCustomInfo4GetGroupMemberInfoOptionHandle(TIMGetGroupDetailInfoOptionHandle handle, TIMGroupCustomInfoHandle custom_info_handle);
	TIM_DECL int SetGroupID4GetGroupMemberInfoOptionHandle(TIMGetGroupMemberInfoOptionHandle handle, char* group_id);
	TIM_DECL int SetFlag4GetGroupMemberInfoOptionHandle(TIMGetGroupMemberInfoOptionHandle handle, TIMGetGroupMemInfoFlag flag);

	TIM_DECL TIMModifyGroupMemberInfoOptionHandle CreateModifyGroupMemberInfoOptionHandle();
	TIM_DECL void DestroyModifyGroupMemberInfoOptionHandle(TIMModifyGroupMemberInfoOptionHandle handle);
	TIM_DECL int SetGroupID4ModifyGroupMemberInfoOptionHandle(TIMModifyGroupMemberInfoOptionHandle handle, char* group_id);
	TIM_DECL int SetMemberID4ModifyGroupMemberInfoOptionHandle(TIMModifyGroupMemberInfoOptionHandle handle, char* member_id);
	TIM_DECL int SetFlag4ModifyGroupMemberInfoOptionHandle(TIMModifyGroupMemberInfoOptionHandle handle, TIMModifyGroupMemberFlag flag);
	TIM_DECL int SetMsgFlag4ModifyGroupMemberInfoOptionHandle(TIMModifyGroupMemberInfoOptionHandle handle, uint32_t flag);
	TIM_DECL int SetRole4ModifyGroupMemberInfoOptionHandle(TIMModifyGroupMemberInfoOptionHandle handle, uint32_t role);
	TIM_DECL int SetShutupTime4ModifyGroupMemberInfoOptionHandle(TIMModifyGroupMemberInfoOptionHandle handle, uint32_t time);
	TIM_DECL int SetCustomInfo4ModifyGroupMemberInfoOptionHandle(TIMModifyGroupMemberInfoOptionHandle handle, TIMGroupCustomInfoHandle custom_info_handle);

	TIM_DECL TIMModifyGroupBaseInfoOptionHandle CreateModifyGroupBaseInfoOptionHandle();
	TIM_DECL void DestroyModifyGroupBaseInfoOptionHandle(TIMModifyGroupBaseInfoOptionHandle handle);
	TIM_DECL int SetGroupId4ModifyGroupBaseInfoOptionHandle(TIMModifyGroupBaseInfoOptionHandle handle, char* group_id);
	TIM_DECL int SetFlag4ModifyGroupBaseInfoOptionHandle(TIMModifyGroupBaseInfoOptionHandle handle, TIMModifyGroupFlag flag);
	TIM_DECL int SetGroupName4ModifyGroupBaseInfoOptionHandle(TIMModifyGroupBaseInfoOptionHandle handle, char* group_name);
	TIM_DECL int SetNotification4ModifyGroupBaseInfoOptionHandle(TIMModifyGroupBaseInfoOptionHandle handle, const char* notification, uint32_t nofi_len);
	TIM_DECL int SetIntroduction4ModifyGroupBaseInfoOptionHandle(TIMModifyGroupBaseInfoOptionHandle handle, const char* introduction, uint32_t intro_len);
	TIM_DECL int SetFaceUrl4ModifyGroupBaseInfoOptionHandle(TIMModifyGroupBaseInfoOptionHandle handle, const char* face_url, uint32_t face_url_len);
	//Ⱥѡ0ֹ룻1Ҫ2룻
	TIM_DECL int SetAddOption4ModifyGroupBaseInfoOptionHandle(TIMModifyGroupBaseInfoOptionHandle handle, const TIMGroupAddOpt add_option);
	TIM_DECL int SetMaxMemberNum4ModifyGroupBaseInfoOptionHandle(TIMModifyGroupBaseInfoOptionHandle handle, uint32_t max_member_num);
	TIM_DECL int SetCustomInfo4ModifyGroupBaseInfoOptionHandle(TIMModifyGroupBaseInfoOptionHandle handle, TIMGroupCustomInfoHandle custom_info_handle);

	TIM_DECL TIMGroupMemberResultHandle CreateGroupMemberResultHandle();
	TIM_DECL void DestroyGroupMemberResultHandle(TIMGroupMemberResultHandle handle);
	TIM_DECL TIMGroupMemberResultHandle CloneGroupMemberResultHandle(TIMGroupMemberResultHandle handle);
	TIM_DECL int GetGroupMemberResultID(TIMGroupMemberResultHandle handle, char* id, uint32_t* len);
	TIM_DECL uint32_t GetGroupMemberResult(TIMGroupMemberResultHandle handle);
	TIM_DECL void SetGroupMemberResultID(TIMGroupMemberResultHandle handle, const char* open_id);
	TIM_DECL void SetGroupMemberResult(TIMGroupMemberResultHandle handle, uint32_t result);

	TIM_DECL TIMGroupBaseInfoHandle CreateGroupBaseInfoHandle();
	TIM_DECL void DestroyGroupBaseInfoHandle(TIMGroupBaseInfoHandle handle);
	TIM_DECL TIMGroupBaseInfoHandle CloneGroupBaseInfoHandle(TIMGroupBaseInfoHandle handle);
	//ȺID
	TIM_DECL int GetGroupBaseInfoID(TIMGroupBaseInfoHandle handle, char* id, uint32_t* len);
	//Ⱥ
	TIM_DECL int GetGroupBaseInfoName(TIMGroupBaseInfoHandle handle, char* name, uint32_t* len);
	//Ⱥ
	TIM_DECL int GetGroupBaseInfoType(TIMGroupBaseInfoHandle handle, char* type, uint32_t* len);
	//ԼϢλ 0գ1
	TIM_DECL uint32_t GetGroupBaseInfoMsgFlag(TIMGroupBaseInfoHandle handle);

	TIM_DECL TIMGroupDetailInfoHandle CreateGroupDetailInfoHandle();
	TIM_DECL void DestroyGroupDetailInfoHandle(TIMGroupDetailInfoHandle handle);
	// ȺId
	TIM_DECL int GetGroupDetailInfoID(TIMGroupDetailInfoHandle handle, char* id, uint32_t* len);
	// Ⱥ
	TIM_DECL int GetGroupDetailInfoName(TIMGroupDetailInfoHandle handle, char* name, uint32_t* len);
	// 
	TIM_DECL int GetGroupDetailInfoOwner(TIMGroupDetailInfoHandle handle, char* owner, uint32_t* len);
	// Ⱥ
	TIM_DECL int GetGroupDetailInfoNotification(TIMGroupDetailInfoHandle handle, char* buf, uint32_t* len);
	// Ⱥ
	TIM_DECL int GetGroupDetailInfoIntroduction(TIMGroupDetailInfoHandle handle, char* buf, uint32_t* len);
	TIM_DECL int GetGroupDetailInfoFaceURL(TIMGroupDetailInfoHandle handle, char* url, uint32_t* len);
	// Ⱥ
	TIM_DECL int GetGroupDetailInfoType(TIMGroupDetailInfoHandle handle, char* type, uint32_t* len);
	TIM_DECL uint32_t GetGroupDetailInfoCreateTime(TIMGroupDetailInfoHandle handle);
	// һ޸ʱ
	TIM_DECL uint32_t GetGroupDetailInfoLastInfoTime(TIMGroupDetailInfoHandle handle);
	// һηϢʱ
	TIM_DECL uint32_t GetGroupDetailInfoLastMsgTime(TIMGroupDetailInfoHandle handle);
	// ȺԱ
	TIM_DECL uint32_t GetGroupDetailInfoMemberNum(TIMGroupDetailInfoHandle handle);
	TIM_DECL uint32_t GetGroupDetailInfoMaxMemberNum(TIMGroupDetailInfoHandle handle);
	TIM_DECL TIMGroupCustomInfoHandle GetGroupDetailInfoCustomInfo(TIMGroupDetailInfoHandle handle);
	TIM_DECL TIMMessageHandle CloneMessageHandleFromGroupDetailInfo(TIMGroupDetailInfoHandle handle);

	TIM_DECL TIMGroupMemberInfoHandle CreateGroupMemberInfoHandle();
	TIM_DECL void DestroyGroupMemberInfoHandle(TIMGroupMemberInfoHandle handle);
	//ȺԱID
	TIM_DECL int GetGroupMemberID(TIMGroupMemberInfoHandle handle, char* id, uint32_t* len);
	//Ⱥʱ
	TIM_DECL uint32_t GetGroupMemberInfoJoinTime(TIMGroupMemberInfoHandle handle);
	//Ա
	TIM_DECL uint32_t GetGroupMemberInfoRole(TIMGroupMemberInfoHandle handle);
	TIM_DECL uint32_t GetGroupMemberInfoMsgFlag(TIMGroupMemberInfoHandle handle);
	TIM_DECL uint32_t GetGroupMemberInfoShutupTime(TIMGroupMemberInfoHandle handle);
	TIM_DECL TIMGroupCustomInfoHandle GetGroupMemberInfoCustomInfo(TIMGroupMemberInfoHandle handle);

// callback for interface
	typedef void (*CBCreateGroupOnSuccess) (const char* group_id, void* data);
	typedef void (*CBCreateGroupOnError) (int code, const char* desc, void* data);
	typedef struct _TIMCallBack_CreateGroup
	{
		CBCreateGroupOnSuccess OnSuccess;
		CBCreateGroupOnError OnError;
		void* data;
	}TIMCreateGroupCB;

	typedef void (*CBDeleteGroupMemberOnSuccess) (TIMGroupMemberResultHandle* handle_array, uint32_t array_size, void* data);
	typedef void (*CBDeleteGroupMemberOnError) (int, const char*, void* data);

	typedef struct _TIMCallBack_DeleteGroupMember
	{
		CBDeleteGroupMemberOnSuccess OnSuccess;
		CBDeleteGroupMemberOnError OnError;
		void* data;
	}TIMDeleteGroupMemberCB;

	typedef TIMDeleteGroupMemberCB TIMInviteGroupMemberCB;

	typedef void (*CBGetGroupListOnSuccess) (TIMGroupBaseInfoHandle* handle_array, uint32_t array_size, void* data);
	typedef void (*CBGetGroupListOnError) (int code, const char* desc, void* data);

	typedef struct _TIMCallBack_GetGroupList
	{
		CBGetGroupListOnSuccess OnSuccess;
		CBGetGroupListOnError OnError;
		void* data;
	}TIMGetGroupListCB;


	typedef void (*CBGetGroupDetailInfoOnSuccess) (TIMGroupDetailInfoHandle* handle_array, uint32_t array_size, void* data);
	typedef void (*CBGetGroupDetailInfoOnError) (int code, const char* desc, void* data);

	typedef struct _TIMCallBack_GetGroupDetailInfo
	{
		CBGetGroupDetailInfoOnSuccess OnSuccess;
		CBGetGroupDetailInfoOnError OnError;
		void* data;
	}TIMGetGroupDetailInfoCB;

	typedef void (*CBGetGroupMemberInfoOnSuccess) (TIMGroupMemberInfoHandle* handle_array, uint32_t array_size, void* data);
	typedef void (*CBGetGroupMemberInfoOnError) (int code, const char* desc, void* data);

	typedef struct _TIMCallBack_GetGroupMemberInfo
	{
		CBGetGroupMemberInfoOnSuccess OnSuccess;
		CBGetGroupMemberInfoOnError OnError;
		void* data;
	}TIMGetGroupMemberInfoCB;

//GROUPS INTERFACE
	TIM_DECL void TIMCreateGroup(const char* group_type, const char** members, uint32_t members_count, const char* group_name, TIMCreateGroupCB* callback);
	TIM_DECL void TIMCreateGroupV2(TIMNewGroupInfoHandle handle, TIMCreateGroupCB* callback);

	TIM_DECL void TIMDeleteGroup(const char* groupid, TIMCommCB * callback);
	TIM_DECL void TIMDeleteGroupMember(const char* groupid, const char** members, uint32_t members_count, const char* reason, uint32_t reason_len, TIMDeleteGroupMemberCB* callback);
	TIM_DECL void TIMInviteGroupMember(const char* groupid, const char** members, uint32_t members_count, TIMInviteGroupMemberCB* callback);

	TIM_DECL void TIMApplyJoinGroup(const char* groupid, const char* hello_msg, TIMCommCB* callback);
	TIM_DECL void TIMQuitGroup(const char* groupid, TIMCommCB* callback);
	TIM_DECL void TIMGetGroupList(TIMGetGroupListCB *callback);
	TIM_DECL void TIMGetGroupPublicInfo(const char** groupids, const uint32_t group_num, const TIMGetGroupBaseInfoFlag flag, TIMGroupCustomInfoHandle custom, TIMGetGroupDetailInfoCB *callback);
	TIM_DECL void TIMModifyGroupName(const char* groupid, const char* groupname, uint32_t name_len, TIMCommCB * callback);
	TIM_DECL void TIMModifyGroupIntroduction(const char* groupid, const char* introduction, uint32_t introduction_len, TIMCommCB * callback);
	TIM_DECL void TIMModifyGroupNotification(const char* groupid, const char* notification, uint32_t notification_len, TIMCommCB * callback);
	TIM_DECL void TIMModifyGroupFaceUrl(const char* groupid, const char* face_url, uint32_t face_url_len, TIMCommCB * callback);
	TIM_DECL void TIMModifyGroupAddOpt(const char* groupid, const TIMGroupAddOpt opt, TIMCommCB * callback);

	TIM_DECL void TIMModifyGroupDatilInfoV2(TIMModifyGroupBaseInfoOptionHandle opt, TIMCommCB * callback);
 	TIM_DECL void TIMGetGroupDetailInfo(const char** groupids, uint32_t groupid_count, TIMGetGroupDetailInfoCB * cb);
	TIM_DECL void TIMGetGroupDetailInfoV2(TIMGetGroupDetailInfoOptionHandle opt, TIMGetGroupDetailInfoCB * cb);
 	TIM_DECL void TIMGetGroupMembers(const char* groupid, TIMGetGroupMemberInfoCB *cb);
	TIM_DECL void TIMGetGroupMembersV2(TIMGetGroupMemberInfoOptionHandle opt, TIMGetGroupMemberInfoCB *cb);
	TIM_DECL void TIMModifyGroupMemberInfo(TIMModifyGroupMemberInfoOptionHandle opt, TIMCommCB * callback);
};

#endif

