#ifndef _TIM_MSG_C_H_
#define _TIM_MSG_C_H_


#include "tim_comm_c.h"

// Ϣ
#define TIM_MSG_STATUS_SENDING 1
// Ϣͳɹ
#define TIM_MSG_STATUS_SEND_SUCC 2
// Ϣʧ
#define TIM_MSG_STATUS_SEND_FAIL 3
// Ϣɾ
#define TIM_MSG_STATUS_HAS_DELETED 4

extern "C"
{
	typedef void* TIMMessageHandle;
	typedef void (*CBOnNewMessage) (TIMMessageHandle handle, void* data);
	typedef struct _TIMMessageCB_C
	{
		CBOnNewMessage OnNewMessage;
		void* data;
	}TIMMessageCB;

	typedef void (*CBGetMsgOnSuccess) (TIMMessageHandle* handle_array, int size, void* data);
	typedef void (*CBGetMsgOnError) (int code, const char* desc, void* data);
	typedef struct _TIMGetMsgCallBack_c
	{
		CBGetMsgOnSuccess OnSuccess;
		CBGetMsgOnError OnError;
		void* data;
	}TIMGetMsgCB;

	typedef void(*CBGetMsgDataOnSuccess) (const char* buf, uint32_t len, void* data);
	typedef void(*CBGetMsgDataOnError) (int code, const char* desc, void* data);

	typedef struct _TIMGetMsgDataCallBack_c
	{
		CBGetMsgDataOnSuccess  OnSuccess;
		CBGetMsgDataOnError	OnError;
		void*		data;
	}TIMGetMsgDataCB;

	typedef void* TIMMsgElemHandle;
	typedef void* TIMMsgTextElemHandle;
	typedef void* TIMMsgImageElemHandle;
	typedef void* TIMMsgCustomElemHandle;
	typedef void* TIMMsgFaceElemHandle;
	typedef void* TIMMsgSoundElemHandle; 
	typedef void* TIMMsgFileElemHandle;
	typedef void* TIMMsgGroupTipsElemHandle; //For Only Recv Group Tips Msg
	typedef void* TIMMsgGroupReportElemHandle;//For Only Recv Group Report Msg
	typedef void* TIMMsgSNSSystemElemHandle; //SNSϵϵͳ֪ͨ
	typedef void* TIMMsgProfileSystemElemHandle; //ϱϵͳ֪ͨ
	
	TIM_DECL TIMMessageHandle	CreateTIMMessage();
	TIM_DECL int				DestroyTIMMessage(TIMMessageHandle handle);
	TIM_DECL TIMMessageHandle	CloneTIMMessage(TIMMessageHandle handle);
	TIM_DECL int				AddElem(TIMMessageHandle msg, TIMMsgElemHandle elem);
	TIM_DECL int				GetElemCount(TIMMessageHandle handle);
	TIM_DECL TIMMsgElemHandle	GetElem(TIMMessageHandle handle, int index);
	TIM_DECL int GetConversationFromMsg(TIMConversationHandle conv, TIMMessageHandle msg);
	TIM_DECL uint32_t			GetMsgTime(TIMMessageHandle handle);
	TIM_DECL bool				IsMsgFromSelf(TIMMessageHandle handle);
	TIM_DECL bool				IsMsgRead(TIMMessageHandle handle);
	TIM_DECL int				GetMsgStatus(TIMMessageHandle handle);
	TIM_DECL int				GetMsgSender(TIMMessageHandle handle, char* buf, uint32_t* len);
	TIM_DECL int				GetMsgID(TIMMessageHandle handle, char* id, uint32_t* len);  //ID󳤶30
	TIM_DECL bool				RemoveMsg(TIMMessageHandle handle);

	TIM_DECL TIMMsgTextElemHandle	CreateMsgTextElem();
	TIM_DECL TIMMsgImageElemHandle	CreateMsgImageElem();
	TIM_DECL TIMMsgImageElemHandle	CloneMsgImageElem(TIMMsgImageElemHandle handle);
	TIM_DECL TIMMsgCustomElemHandle CreateCustomElemHandle();
	TIM_DECL TIMMsgFaceElemHandle	CreateFaceElemHandle();
	TIM_DECL TIMMsgSoundElemHandle	CreateSoundElemHandle();
	TIM_DECL TIMMsgFileElemHandle	CreateFileElemHandle();
	
	TIM_DECL void					DestroyElem(TIMMsgElemHandle handle);
	TIM_DECL void					SetElemType(TIMMsgElemHandle handle, TIMElemType type);
	TIM_DECL TIMElemType			GetElemType(TIMMsgElemHandle handle);

	TIM_DECL void	SetContent(TIMMsgTextElemHandle handle, const char* content);
	TIM_DECL uint32_t	GetContentLen(TIMMsgTextElemHandle handle);
	TIM_DECL int	GetContent(TIMMsgTextElemHandle handle, char* content, uint32_t* len);

	typedef void* TIMImageHandle;
	TIM_DECL TIMImageType	GetImageType(TIMImageHandle handle);
	TIM_DECL uint32_t	GetImageSize(TIMImageHandle handle);
	TIM_DECL uint32_t	GetImageHeight(TIMImageHandle handle);
	TIM_DECL uint32_t	GetImageWidth(TIMImageHandle handle);
	TIM_DECL uint32_t	GetImageURLLen(TIMImageHandle handle);
	TIM_DECL int		GetImageURL(TIMImageHandle handle, char* url, uint32_t* len);
	TIM_DECL int		GetImageFile(TIMImageHandle handle, char* filename, TIMCommCB* cb);

	TIM_DECL int		GetImageElemUUID(TIMMsgImageElemHandle handle, char* buf, uint32_t* len);
	TIM_DECL int		GetImageElemTaskID(TIMMsgImageElemHandle handle);
	TIM_DECL bool		CancelImageElemUploading(TIMMsgImageElemHandle handle);
	TIM_DECL int		GetImageUploadingProgress(TIMMsgImageElemHandle handle);
	TIM_DECL int		GetImageElemPath(TIMMsgImageElemHandle handle, char* path, uint32_t* len);
	TIM_DECL void		SetImageElemPath(TIMMsgImageElemHandle handle, const char* path, uint32_t len);
	TIM_DECL void		SetImageCompressLeval(TIMMsgImageElemHandle handle, const TIM_IMAGE_COMPRESS_TYPE leval);
	TIM_DECL uint32_t	GetImageNum(TIMMsgImageElemHandle handle);
	TIM_DECL int		GetImages(TIMMsgImageElemHandle handle, TIMImageHandle* images, uint32_t* num);


	TIM_DECL uint32_t	GetCustomElemDataLen(TIMMsgCustomElemHandle handle);
	TIM_DECL int		GetCustomElemData(TIMMsgCustomElemHandle handle, char* date, uint32_t* len);
	TIM_DECL void		SetCustomElemData(TIMMsgCustomElemHandle handle, const char* date, uint32_t len);
	TIM_DECL int		GetCustomElemDesc(TIMMsgCustomElemHandle handle, char* desc, uint32_t* len);
	TIM_DECL void		SetCustomElemDesc(TIMMsgCustomElemHandle handle, const char* desc, uint32_t len);


	TIM_DECL int		GetFaceElemIndex(TIMMsgFaceElemHandle handle);
	TIM_DECL uint32_t	GetFaceElemDataLen(TIMMsgFaceElemHandle handle);
	TIM_DECL int		GetFaceElemData(TIMMsgCustomElemHandle handle, char* date, uint32_t* len);
	TIM_DECL void		SetFaceElemIndex(TIMMsgFaceElemHandle handle, int index);
	TIM_DECL void		SetFaceElemIndexData(TIMMsgCustomElemHandle handle, const char* date, uint32_t len);

	TIM_DECL void		SetSoundElemData(TIMMsgSoundElemHandle handle, const char* data, uint32_t len);
	TIM_DECL void		SetSoundElemDuration(TIMMsgSoundElemHandle handle, const uint32_t duration);
	TIM_DECL uint32_t	GetSoundElemDuration(TIMMsgSoundElemHandle handle);
	TIM_DECL int		GetSoundElemUUID(TIMMsgSoundElemHandle handle, char* id, uint32_t* id_len);
	TIM_DECL void		GetSoundFromSoundElem(TIMMsgSoundElemHandle handle, TIMGetMsgDataCB* cb);

	TIM_DECL void		SetFileElemFileName(TIMMsgFileElemHandle handle, const char* name, uint32_t name_len);
	TIM_DECL int		GetFileElemFileName(TIMMsgFileElemHandle handle, char* name, uint32_t* name_len);
	TIM_DECL void		SetFileElemData(TIMMsgFileElemHandle handle, const char* data, uint32_t data_len);
	TIM_DECL int		GetFileElemUUID(TIMMsgFileElemHandle handle, char* id, uint32_t* len);
	TIM_DECL void		GetFileFromFileElem(TIMMsgFileElemHandle handle, TIMGetMsgDataCB* cb);
	
	

	typedef void* TIMGroupChangeInfoHandle;

#define TIM_GROUP_INFO_CHAGE_TYPE_GROUP_NAME	0x1 //Ⱥ
#define TIM_GROUP_INFO_CHAGE_TYPE_INTRODUCTION	0x2 //Ⱥ
#define	TIM_GROUP_INFO_CHAGE_TYPE_NOTIFACTION	0x3 //Ⱥ֪ͨ
#define TIM_GROUP_INFO_CHAGE_TYPE_FACE_URL		0x4 //Ⱥͷ
#define TIM_GROUP_INFO_CHAGE_TYPE_OWNER			0x5 //Ⱥ

	TIM_DECL int	  GetGroupChangeInfoType(TIMGroupChangeInfoHandle handle);
	TIM_DECL uint32_t GetGroupChangeInfoLen(TIMGroupChangeInfoHandle handle);
	TIM_DECL uint32_t GetGroupChangeInfo(TIMGroupChangeInfoHandle handle, char* info, uint32_t *len);

	typedef void* TIMGroupMemberInfoChangeHanlde;
	TIM_DECL int GetGroupMemberChangeInfoID(TIMGroupMemberInfoChangeHanlde handle, char* id, uint32_t * len);
	TIM_DECL uint32_t TIMGetGroupMemberChangeInfoShutTime(TIMGroupMemberInfoChangeHanlde handle);

	typedef void* TIMGroupTipsUserInfoHandle;
	TIM_DECL int GetGroupTipsUserInfoID(TIMGroupTipsUserInfoHandle handle, char* id, uint32_t * len);

	typedef enum _E_TIM_GROUPTIPS_TYPE
	{
		TIM_GROUP_TIPS_TYPE_INVITE              = 0x01, //Ⱥ
		TIM_GROUP_TIPS_TYPE_QUIT_GRP            = 0x02, //˳Ⱥ
		TIM_GROUP_TIPS_TYPE_KICKED              = 0x03, //߳Ⱥ 
		TIM_GROUP_TIPS_TYPE_SET_ADMIN           = 0x04, //ùԱ
		TIM_GROUP_TIPS_TYPE_CANCEL_ADMIN        = 0x05, //ȡԱ
		TIM_GROUP_TIPS_TYPE_INFO_CHANGE         = 0x06, //Ⱥϱ
		TIM_GROUP_TIPS_TYPE_MEMBER_INFO_CHANGE  = 0x07, //ȺԱϱ 
	}E_TIM_GROUPTIPS_TYPE;

	//ȺTips
	TIM_DECL E_TIM_GROUPTIPS_TYPE	GetGroupTipsInfoType(TIMMsgGroupTipsElemHandle handle);
	//Ⱥ
	TIM_DECL int	GetGroupTipsInfoGroupName(TIMMsgGroupTipsElemHandle handle, char* group_name, uint32_t * len);
	//ID
	TIM_DECL int	GetGroupTipsInfoOperatorID(TIMMsgGroupTipsElemHandle handle, char* id, uint32_t * len);
	//б
	TIM_DECL uint32_t	GetGroupTipsInfoUsersNum(TIMMsgGroupTipsElemHandle handle);
	TIM_DECL int	GetGroupTipsInfoUsers(TIMMsgGroupTipsElemHandle handle, TIMGroupTipsUserInfoHandle* handles, uint32_t* num);
	//ȺϢб
	TIM_DECL uint32_t	GetGroupTipsInfoGroupChangeInfoNum(TIMMsgGroupTipsElemHandle handle);
	TIM_DECL int	GetGroupTipsInfoGroupChangeInfo(TIMMsgGroupTipsElemHandle handle, TIMGroupChangeInfoHandle* handles, uint32_t* num);
	//ȺԱб
	TIM_DECL uint32_t	GetGroupTipsInfoMemberChangeInfoNum(TIMMsgGroupTipsElemHandle handle);
	TIM_DECL int	GetGroupTipsInfoMemberChangeInfo(TIMMsgGroupTipsElemHandle handle, TIMGroupMemberInfoChangeHanlde* handles, uint32_t* num);

	//ȺϵͳϢ
	typedef enum _E_TIM_GROUP_SYSTEM_TYPE
	{
		TIM_GROUP_SYSTEM_ADD_GROUP_REQUEST_TYPE		= 0x01, //ȺֻйԱյ
		TIM_GROUP_SYSTEM_ADD_GROUP_ACCEPT_TYPE      = 0x02,//Ⱥͬ⣨ֻܹյ
		TIM_GROUP_SYSTEM_ADD_GROUP_REFUSE_TYPE      = 0x03,//Ⱥֻܾܹյ
		TIM_GROUP_SYSTEM_KICK_OFF_FROM_GROUP_TYPE	= 0x04,//Ա߳Ⱥֻбߵܹյ
		TIM_GROUP_SYSTEM_DELETE_GROUP_TYPE			= 0x05,//ȺɢȫԱܹյ
		TIM_GROUP_SYSTEM_CREATE_GROUP_TYPE			= 0x06,//ȺϢܹյ
		TIM_GROUP_SYSTEM_INVITED_TO_GROUP_TYPE		= 0x07,//Ⱥܹյ
		TIM_GROUP_SYSTEM_QUIT_GROUP_TYPE			= 0x08,//ȺȺܹյ
		TIM_GROUP_SYSTEM_GRANT_ADMIN_TYPE			= 0x09,//ùԱ(߽)
		TIM_GROUP_SYSTEM_CANCEL_ADMIN_TYPE			= 0x0a,//ȡԱ(ȡ߽)
		TIM_GROUP_SYSTEM_REVOKE_GROUP_TYPE			= 0x0b,//Ⱥѱ(ȫԱ)
		TIM_GROUP_SYSTEM_CUSTOM_INFO				= 0xff,//ûԶ֪ͨ(ĬȫԱ)
	}E_TIM_GROUP_SYSTEM_TYPE;

	//
	TIM_DECL E_TIM_GROUP_SYSTEM_TYPE	GetGroupReportType(TIMMsgGroupReportElemHandle handle);
	//ȺId
	TIM_DECL int	GetGroupReportID(TIMMsgGroupReportElemHandle handle, char* id, uint32_t* len);
	//Ⱥ
	TIM_DECL int	GetGroupReportName(TIMMsgGroupReportElemHandle handle, char* group_name, uint32_t* len);
	//
	TIM_DECL int	GetGroupReportOperatorID(TIMMsgGroupReportElemHandle handle, char* id, uint32_t* len);
	//
	TIM_DECL int	GetGroupReportRemarkInfoLen(TIMMsgGroupReportElemHandle handle);
	TIM_DECL int	GetGroupReportRemarkInfo(TIMMsgGroupReportElemHandle handle, char* remark_info, uint32_t* len);
	//ûԶ֪ͨ
	TIM_DECL uint32_t GetGroupReportUserDataLen(TIMMsgGroupReportElemHandle handle);
	TIM_DECL int	GetGroupReportUserData(TIMMsgGroupReportElemHandle handle, char* user_data, uint32_t* len);

	//Ⱥ룬ĿǰֻȺϢЧ
	// 0x00:ܾȺ
	// 0x01:ͬȺ
	TIM_DECL int	HandleJoinRequest(TIMMsgGroupReportElemHandle handle, int flag, TIMCommCB* cb);

	//ϵϢ
	typedef enum _E_TIM_SNS_SYSTEM_TYPE
	{
		TIM_SNS_SYSTEM_ADD_FRIEND = 0x01,//Ӻϵͳ֪ͨ
		TIM_SNS_SYSTEM_DEL_FRIEND = 0x02,//ɾϵͳ֪ͨ
		TIM_SNS_SYSTEM_ADD_FRIEND_REQ = 0x03,//ϵͳ֪ͨ
		TIM_SNS_SYSTEM_DEL_FRIEND_REQ = 0x04,//ɾδ֪ͨ
		TIM_SNS_SYSTEM_ADD_BLACKLIST = 0x05,//
		TIM_SNS_SYSTEM_DEL_BLACKLIST = 0x06,//ɾ
		TIM_SNS_SYSTEM_PENDENCY_REPORT = 0x07, //δѶϱ
		TIM_SNS_SYSTEM_SNS_PROFILE_CHANGE = 0x08, //ݸ
		TIM_SNS_SYSTEM_ADD_RECOMMEND = 0x09, //Ƽ
		TIM_SNS_SYSTEM_DEL_RECOMMEND = 0x0a, //Ƽɾ
		TIM_SNS_SYSTEM_ADD_DECIDE = 0x0b, //Ѿ
		TIM_SNS_SYSTEM_DEL_DECIDE = 0x0c, //Ѿɾ
		TIM_SNS_SYSTEM_RECOMMEND_REPORT = 0x0d, //ƼѶϱ
		TIM_SNS_SYSTEM_DECIDE_REPORT = 0x0e, //ѾѶϱ
	}E_TIM_SNS_SYSTEM_TYPE;

	typedef void* TIMMsgSNSChangeInfoHandle;
	TIM_DECL int GetID4SNSChangeInfoHandle(TIMMsgSNSChangeInfoHandle handle, char* id, uint32_t* len);
	TIM_DECL int GetNick4SNSChangeInfoHandle(TIMMsgSNSChangeInfoHandle handle, char* nick, uint32_t* len);
	TIM_DECL int GetAddWord4SNSChangeInfoHandle(TIMMsgSNSChangeInfoHandle handle, char* word, uint32_t* len);
	TIM_DECL int GetAddSource4SNSChangeInfoHandle(TIMMsgSNSChangeInfoHandle handle, char* source, uint32_t* len);
	TIM_DECL int GetRemark4SNSChangeInfoHandle(TIMMsgSNSChangeInfoHandle handle, char* remark, uint32_t* len);

	TIM_DECL E_TIM_SNS_SYSTEM_TYPE GetType4SNSSystemElem(TIMMsgSNSSystemElemHandle handle);
	TIM_DECL uint32_t GetChangeInfoNum4SNSSystemElem(TIMMsgSNSSystemElemHandle handle);
	TIM_DECL int GetChangeInfo4SNSSystemElem(TIMMsgSNSSystemElemHandle elem_handle, TIMMsgSNSChangeInfoHandle* info_handle, uint32_t* num);
	//TIM_SNS_SYSTEM_PENDENCY_REPORT
	TIM_DECL uint64_t GetPendencyReportTimestamp4SNSSystemElem(TIMMsgSNSSystemElemHandle elem_handle);
	//TIM_SNS_SYSTEM_RECOMMEND_REPORT
	TIM_DECL uint64_t GetRecommendReportTimestamp4SNSSystemElem(TIMMsgSNSSystemElemHandle elem_handle);
	//TIM_SNS_SYSTEM_DECIDE_REPORT Ч
	TIM_DECL uint64_t GetDecideReportTimestamp4SNSSystemElem(TIMMsgSNSSystemElemHandle elem_handle);
	
	typedef enum _E_TIM_PROFILE_SYSTEM_TYPE
	{
		TIM_PROFILE_SYSTEM_FRIEND_PROFILE_CHANGE = 0x01,//ϱ
	}E_TIM_PROFILE_SYSTEM_TYPE;

	TIM_DECL E_TIM_PROFILE_SYSTEM_TYPE GetType4ProfileProfileSystemElemHandle(TIMMsgProfileSystemElemHandle handle);
	TIM_DECL int GetID4ProfileProfileSystemElemHandle(TIMMsgProfileSystemElemHandle handle, char* id, uint32_t* len);
	TIM_DECL int GetNick4ProfileProfileSystemElemHandle(TIMMsgProfileSystemElemHandle handle, char* nick, uint32_t* len);
};
#endif



	