#ifndef __TIM_INT_MANAGER_H__
#define __TIM_INT_MANAGER_H__

#include <list>

#include "tim_comm.h"

namespace imcore {

enum E_TIMStreamEncode
{
    //FLVƵURL
    HLS = 0x01,
    //HLSƵURL
    FLV = 0x02,
	//ͬʱHLSFLVƵURL
    HLS_AND_FLV = 0x03,
	//RAW
	RAW = 0X04,
};


struct TIMLiveUrl
{
    int encode_type; //Ƶ
    std::string url; //ƵURL
};

struct TIMRecordParam
{
	TIMRecordParam()
		:class_id(0)
		, is_transcode(false)
		, is_screenshot(false)
		, is_watermark(false){}
	std::string filename;				//¼ƺļ
	int class_id;				 		//ƵID
	bool is_transcode;					//Ƿת
	bool is_screenshot;				 	//Ƿͼ
	bool is_watermark;					//Ƿˮӡ
	std::list<std::string> tags;	 	//Ƶǩб
};

class TIM_DECL TIMIntManager {
public:
	static TIMIntManager &get();
	TIMIntManager();
	uint64_t tiny_id();
	void Init(TIMCallBack *cb);
	void Uninit(TIMCallBack *cb);
	void UserIdToTinyId(std::list<TIMUser> &reqList, TIMValueCallBack<const std::list<TIMUser> &> *cb, uint64_t timeout = 5000);
    void TinyIdToUserId(std::list<uint64_t> &tinyids, TIMValueCallBack<const std::list<TIMUser> &> *cb, uint64_t timeout = 5000);
	void MultiVideoApp(const std::string &req, TIMValueCallBack<const std::string &> *cb, uint64_t timeout = 5000);
	void MultiVideoInfo(const std::string &req, TIMValueCallBack<const std::string &> *cb, uint64_t timeout = 5000);
	void RequestSharpSvr(uint64_t touin, const std::string &req, TIMCallBack *cb, uint64_t timeout = 5000);
	void ResponseSharpSvr(uint64_t touin, const std::string &req, TIMCallBack *cb, uint64_t timeout = 5000);
	void SetSharpSvrPushCallBack(TIMValueCallBack<const std::string &> *cb);
	TIMValueCallBack<const std::string &> *GetSharpSvrPushCallBack();
	void SetSharpSvrRspCallBack(TIMValueCallBack<const std::string &> *cb);
	TIMValueCallBack<const std::string &> *GetSharpSvrRspCallBack();
	void Request(const std::string &cmd, const std::string &req, TIMValueCallBack<const std::string &> *cb, uint64_t timeout = 5000);

	bool ready();

	 /**
     * ʼ
     *
     * @param relationid	ID
     * @param roomid		ID
     * @param signature		ǩûǩΪnull
     * @param encode_type	ҪƵ
     * @param cb         onSuccessзطõurlб, liveUrl
     */
	void RequestMultiVideoStreamerStart(int relation_id, int room_id, const std::string& signature, E_TIMStreamEncode encode_type, TIMValueCallBack<std::list<TIMLiveUrl>& > *cb);
	  /**
     * 
     *
     * @param relation_id    ID
     * @param room_id	     ID
     * @param signature		ǩûǩΪnull
     * @param encodeType ҪƵ
     * @param cb			onSuccessзطõurlб, liveUrl
     */
	void RequestMultiVideoStreamerStop(int relation_id, int room_id, const std::string& signature,E_TIMStreamEncode encode_type, TIMValueCallBack<std::list<TIMLiveUrl>& > *cb);
	   /**
     * ʼ¼
     *
     * @param relation_id   ID
     * @param room_id	    ID
     * @param signature		ǩûǩΪnull
     * @param para			¼Ʋ
     * @param cb
     */
	void RequestMultiVideoRecorderStart(int relation_id, int room_id, const std::string& signature, const TIMRecordParam& para, TIMCallBack* cb);
	   /**
     * ¼
     *
     * @param relation_id   ID
     * @param room_id	    ID
     * @param signature		ǩ
     * @param cb
     */
	void RequestMultiVideoRecorderStop(int relation_id, int room_id, const std::string& signature, TIMCallBack* cb);


	/**
	 *  ͶƵ
	 *
	 *  @param bussType ҵ
	 *  @param authType Ȩ
	 *  @param authid  ȨID
	 *  @param requestType:
	 *  1-----𷢷Ƶ
		2-----ȡƵ
		3-----շƵ
		4-----շܾƵ
	 *  @param receivers  Щ˷
	 */
	void RequestVideoInvitation(int bussType, int authType, int auth_id, int requestType, std::list<TIMUser>& receivers, TIMCallBack* cb);

    /**
     * ϱ(internal)
     * @param type ҵ
     * @param data ģԶϱ
     * @param cb صӿ
     */
	void RequestQualityReport(int type, std::string& data, TIMCallBack* cb);

	/**
	* Ƶ
	*
	* @param bussi_type ҵ
	* @param auth_type  Ȩ
	* @param cb         صӿ
	*/
	void RequestMeasureSpeed(uint16_t bussi_type, uint16_t auth_type, TIMCallBack* cb);
private:
	bool ready_;
};

}

#endif
